

# AWS IoT Core Device Advisor
<a name="API_Operations_AWS_IoT_Core_Device_Advisor"></a>

The following actions are supported by AWS IoT Core Device Advisor:
+  [CreateSuiteDefinition](API_iotdeviceadvisor_CreateSuiteDefinition.md) 
+  [DeleteSuiteDefinition](API_iotdeviceadvisor_DeleteSuiteDefinition.md) 
+  [GetEndpoint](API_iotdeviceadvisor_GetEndpoint.md) 
+  [GetSuiteDefinition](API_iotdeviceadvisor_GetSuiteDefinition.md) 
+  [GetSuiteRun](API_iotdeviceadvisor_GetSuiteRun.md) 
+  [GetSuiteRunReport](API_iotdeviceadvisor_GetSuiteRunReport.md) 
+  [ListSuiteDefinitions](API_iotdeviceadvisor_ListSuiteDefinitions.md) 
+  [ListSuiteRuns](API_iotdeviceadvisor_ListSuiteRuns.md) 
+  [ListTagsForResource](API_iotdeviceadvisor_ListTagsForResource.md) 
+  [StartSuiteRun](API_iotdeviceadvisor_StartSuiteRun.md) 
+  [StopSuiteRun](API_iotdeviceadvisor_StopSuiteRun.md) 
+  [TagResource](API_iotdeviceadvisor_TagResource.md) 
+  [UntagResource](API_iotdeviceadvisor_UntagResource.md) 
+  [UpdateSuiteDefinition](API_iotdeviceadvisor_UpdateSuiteDefinition.md) 

# CreateSuiteDefinition
<a name="API_iotdeviceadvisor_CreateSuiteDefinition"></a>

Creates a Device Advisor test suite.

Requires permission to access the [CreateSuiteDefinition](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_RequestSyntax"></a>

```
POST /suiteDefinitions HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "suiteDefinitionConfiguration": { 
      "devicePermissionRoleArn": "string",
      "devices": [ 
         { 
            "certificateArn": "string",
            "deviceRoleArn": "string",
            "thingArn": "string"
         }
      ],
      "intendedForQualification": boolean,
      "isLongDurationTest": boolean,
      "protocol": "string",
      "rootGroup": "string",
      "suiteDefinitionName": "string"
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_iotdeviceadvisor_CreateSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-request-clientToken"></a>
A unique case-sensitive identifier that you can provide to ensure the idempotency of the request. Don't reuse this client token if a new idempotent request is required.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^[\u0021-\u007E]+$`   
Required: No

 ** [suiteDefinitionConfiguration](#API_iotdeviceadvisor_CreateSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-request-suiteDefinitionConfiguration"></a>
Creates a Device Advisor test suite with suite definition configuration.  
Type: [SuiteDefinitionConfiguration](API_iotdeviceadvisor_SuiteDefinitionConfiguration.md) object  
Required: Yes

 ** [tags](#API_iotdeviceadvisor_CreateSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-request-tags"></a>
The tags to be attached to the suite definition.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: No

## Response Syntax
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "createdAt": number,
   "suiteDefinitionArn": "string",
   "suiteDefinitionId": "string",
   "suiteDefinitionName": "string"
}
```

## Response Elements
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [createdAt](#API_iotdeviceadvisor_CreateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-response-createdAt"></a>
The timestamp of when the test suite was created.  
Type: Timestamp

 ** [suiteDefinitionArn](#API_iotdeviceadvisor_CreateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-response-suiteDefinitionArn"></a>
The Amazon Resource Name (ARN) of the test suite.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_CreateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-response-suiteDefinitionId"></a>
The UUID of the test suite created.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [suiteDefinitionName](#API_iotdeviceadvisor_CreateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_CreateSuiteDefinition-response-suiteDefinitionName"></a>
The suite definition name of the test suite. This is a required parameter.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.

## Errors
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_CreateSuiteDefinition_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/CreateSuiteDefinition) 

# DeleteSuiteDefinition
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition"></a>

Deletes a Device Advisor test suite.

Requires permission to access the [DeleteSuiteDefinition](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_RequestSyntax"></a>

```
DELETE /suiteDefinitions/suiteDefinitionId HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_DeleteSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_DeleteSuiteDefinition-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite to be deleted.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_DeleteSuiteDefinition_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/DeleteSuiteDefinition) 

# GetEndpoint
<a name="API_iotdeviceadvisor_GetEndpoint"></a>

Gets information about an Device Advisor endpoint.

## Request Syntax
<a name="API_iotdeviceadvisor_GetEndpoint_RequestSyntax"></a>

```
GET /endpoint?authenticationMethod=authenticationMethod&certificateArn=certificateArn&deviceRoleArn=deviceRoleArn&thingArn=thingArn HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_GetEndpoint_RequestParameters"></a>

The request uses the following URI parameters.

 ** [authenticationMethod](#API_iotdeviceadvisor_GetEndpoint_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetEndpoint-request-uri-authenticationMethod"></a>
The authentication method used during the device connection.  
Valid Values: `X509ClientCertificate | SignatureVersion4` 

 ** [certificateArn](#API_iotdeviceadvisor_GetEndpoint_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetEndpoint-request-uri-certificateArn"></a>
The certificate ARN of the device. This is an optional parameter.  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [deviceRoleArn](#API_iotdeviceadvisor_GetEndpoint_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetEndpoint-request-uri-deviceRoleArn"></a>
The device role ARN of the device. This is an optional parameter.  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [thingArn](#API_iotdeviceadvisor_GetEndpoint_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetEndpoint-request-uri-thingArn"></a>
The thing ARN of the device. This is an optional parameter.  
Length Constraints: Minimum length of 20. Maximum length of 2048.

## Request Body
<a name="API_iotdeviceadvisor_GetEndpoint_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_GetEndpoint_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "endpoint": "string"
}
```

## Response Elements
<a name="API_iotdeviceadvisor_GetEndpoint_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [endpoint](#API_iotdeviceadvisor_GetEndpoint_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetEndpoint-response-endpoint"></a>
The response of an Device Advisor endpoint.  
Type: String  
Length Constraints: Minimum length of 45. Maximum length of 75.

## Errors
<a name="API_iotdeviceadvisor_GetEndpoint_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_GetEndpoint_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/GetEndpoint) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/GetEndpoint) 

# GetSuiteDefinition
<a name="API_iotdeviceadvisor_GetSuiteDefinition"></a>

Gets information about a Device Advisor test suite.

Requires permission to access the [GetSuiteDefinition](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_GetSuiteDefinition_RequestSyntax"></a>

```
GET /suiteDefinitions/suiteDefinitionId?suiteDefinitionVersion=suiteDefinitionVersion HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_GetSuiteDefinition_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_GetSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite to get.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_GetSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-request-uri-suiteDefinitionVersion"></a>
Suite definition version of the test suite to get.  
Length Constraints: Minimum length of 2. Maximum length of 255.

## Request Body
<a name="API_iotdeviceadvisor_GetSuiteDefinition_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "createdAt": number,
   "lastModifiedAt": number,
   "latestVersion": "string",
   "suiteDefinitionArn": "string",
   "suiteDefinitionConfiguration": { 
      "devicePermissionRoleArn": "string",
      "devices": [ 
         { 
            "certificateArn": "string",
            "deviceRoleArn": "string",
            "thingArn": "string"
         }
      ],
      "intendedForQualification": boolean,
      "isLongDurationTest": boolean,
      "protocol": "string",
      "rootGroup": "string",
      "suiteDefinitionName": "string"
   },
   "suiteDefinitionId": "string",
   "suiteDefinitionVersion": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_iotdeviceadvisor_GetSuiteDefinition_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [createdAt](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-createdAt"></a>
Date (in Unix epoch time) when the suite definition was created.  
Type: Timestamp

 ** [lastModifiedAt](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-lastModifiedAt"></a>
Date (in Unix epoch time) when the suite definition was last modified.  
Type: Timestamp

 ** [latestVersion](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-latestVersion"></a>
Latest suite definition version of the suite definition.  
Type: String  
Length Constraints: Minimum length of 2. Maximum length of 255.

 ** [suiteDefinitionArn](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-suiteDefinitionArn"></a>
The ARN of the suite definition.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [suiteDefinitionConfiguration](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-suiteDefinitionConfiguration"></a>
Suite configuration of the suite definition.  
Type: [SuiteDefinitionConfiguration](API_iotdeviceadvisor_SuiteDefinitionConfiguration.md) object

 ** [suiteDefinitionId](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-suiteDefinitionId"></a>
Suite definition ID of the suite definition.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-suiteDefinitionVersion"></a>
Suite definition version of the suite definition.  
Type: String  
Length Constraints: Minimum length of 2. Maximum length of 255.

 ** [tags](#API_iotdeviceadvisor_GetSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteDefinition-response-tags"></a>
Tags attached to the suite definition.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.

## Errors
<a name="API_iotdeviceadvisor_GetSuiteDefinition_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_GetSuiteDefinition_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/GetSuiteDefinition) 

# GetSuiteRun
<a name="API_iotdeviceadvisor_GetSuiteRun"></a>

Gets information about a Device Advisor test suite run.

Requires permission to access the [GetSuiteRun](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_GetSuiteRun_RequestSyntax"></a>

```
GET /suiteDefinitions/suiteDefinitionId/suiteRuns/suiteRunId HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_GetSuiteRun_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_GetSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-request-uri-suiteDefinitionId"></a>
Suite definition ID for the test suite run.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

 ** [suiteRunId](#API_iotdeviceadvisor_GetSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-request-uri-suiteRunId"></a>
Suite run ID for the test suite run.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_GetSuiteRun_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "endTime": number,
   "errorReason": "string",
   "startTime": number,
   "status": "string",
   "suiteDefinitionId": "string",
   "suiteDefinitionVersion": "string",
   "suiteRunArn": "string",
   "suiteRunConfiguration": { 
      "parallelRun": boolean,
      "primaryDevice": { 
         "certificateArn": "string",
         "deviceRoleArn": "string",
         "thingArn": "string"
      },
      "selectedTestList": [ "string" ]
   },
   "suiteRunId": "string",
   "tags": { 
      "string" : "string" 
   },
   "testResult": { 
      "groups": [ 
         { 
            "groupId": "string",
            "groupName": "string",
            "tests": [ 
               { 
                  "endTime": number,
                  "failure": "string",
                  "logUrl": "string",
                  "startTime": number,
                  "status": "string",
                  "testCaseDefinitionId": "string",
                  "testCaseDefinitionName": "string",
                  "testCaseRunId": "string",
                  "testScenarios": [ 
                     { 
                        "failure": "string",
                        "status": "string",
                        "systemMessage": "string",
                        "testCaseScenarioId": "string",
                        "testCaseScenarioType": "string"
                     }
                  ],
                  "warnings": "string"
               }
            ]
         }
      ]
   }
}
```

## Response Elements
<a name="API_iotdeviceadvisor_GetSuiteRun_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [endTime](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-endTime"></a>
Date (in Unix epoch time) when the test suite run ended.  
Type: Timestamp

 ** [errorReason](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-errorReason"></a>
Error reason for any test suite run failure.  
Type: String

 ** [startTime](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-startTime"></a>
Date (in Unix epoch time) when the test suite run started.  
Type: Timestamp

 ** [status](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-status"></a>
Status for the test suite run.  
Type: String  
Valid Values: `PASS | FAIL | CANCELED | PENDING | RUNNING | STOPPING | STOPPED | PASS_WITH_WARNINGS | ERROR` 

 ** [suiteDefinitionId](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-suiteDefinitionId"></a>
Suite definition ID for the test suite run.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-suiteDefinitionVersion"></a>
Suite definition version for the test suite run.  
Type: String  
Length Constraints: Minimum length of 2. Maximum length of 255.

 ** [suiteRunArn](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-suiteRunArn"></a>
The ARN of the suite run.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [suiteRunConfiguration](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-suiteRunConfiguration"></a>
Suite run configuration for the test suite run.  
Type: [SuiteRunConfiguration](API_iotdeviceadvisor_SuiteRunConfiguration.md) object

 ** [suiteRunId](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-suiteRunId"></a>
Suite run ID for the test suite run.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [tags](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-tags"></a>
The tags attached to the suite run.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.

 ** [testResult](#API_iotdeviceadvisor_GetSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRun-response-testResult"></a>
Test results for the test suite run.  
Type: [TestResult](API_iotdeviceadvisor_TestResult.md) object

## Errors
<a name="API_iotdeviceadvisor_GetSuiteRun_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_GetSuiteRun_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/GetSuiteRun) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/GetSuiteRun) 

# GetSuiteRunReport
<a name="API_iotdeviceadvisor_GetSuiteRunReport"></a>

Gets a report download link for a successful Device Advisor qualifying test suite run.

Requires permission to access the [GetSuiteRunReport](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_GetSuiteRunReport_RequestSyntax"></a>

```
GET /suiteDefinitions/suiteDefinitionId/suiteRuns/suiteRunId/report HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_GetSuiteRunReport_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_GetSuiteRunReport_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRunReport-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

 ** [suiteRunId](#API_iotdeviceadvisor_GetSuiteRunReport_RequestSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRunReport-request-uri-suiteRunId"></a>
Suite run ID of the test suite run.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_GetSuiteRunReport_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_GetSuiteRunReport_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "qualificationReportDownloadUrl": "string"
}
```

## Response Elements
<a name="API_iotdeviceadvisor_GetSuiteRunReport_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [qualificationReportDownloadUrl](#API_iotdeviceadvisor_GetSuiteRunReport_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_GetSuiteRunReport-response-qualificationReportDownloadUrl"></a>
Download URL of the qualification report.  
Type: String

## Errors
<a name="API_iotdeviceadvisor_GetSuiteRunReport_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_GetSuiteRunReport_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/GetSuiteRunReport) 

# ListSuiteDefinitions
<a name="API_iotdeviceadvisor_ListSuiteDefinitions"></a>

Lists the Device Advisor test suites you have created.

Requires permission to access the [ListSuiteDefinitions](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_RequestSyntax"></a>

```
GET /suiteDefinitions?maxResults=maxResults&nextToken=nextToken HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_iotdeviceadvisor_ListSuiteDefinitions_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteDefinitions-request-uri-maxResults"></a>
The maximum number of results to return at once.  
Valid Range: Minimum value of 1. Maximum value of 50.

 ** [nextToken](#API_iotdeviceadvisor_ListSuiteDefinitions_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteDefinitions-request-uri-nextToken"></a>
A token used to get the next set of results.  
Length Constraints: Maximum length of 2000.

## Request Body
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "suiteDefinitionInformationList": [ 
      { 
         "createdAt": number,
         "defaultDevices": [ 
            { 
               "certificateArn": "string",
               "deviceRoleArn": "string",
               "thingArn": "string"
            }
         ],
         "intendedForQualification": boolean,
         "isLongDurationTest": boolean,
         "protocol": "string",
         "suiteDefinitionId": "string",
         "suiteDefinitionName": "string"
      }
   ]
}
```

## Response Elements
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_iotdeviceadvisor_ListSuiteDefinitions_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteDefinitions-response-nextToken"></a>
A token used to get the next set of results.  
Type: String  
Length Constraints: Maximum length of 2000.

 ** [suiteDefinitionInformationList](#API_iotdeviceadvisor_ListSuiteDefinitions_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteDefinitions-response-suiteDefinitionInformationList"></a>
An array of objects that provide summaries of information about the suite definitions in the list.  
Type: Array of [SuiteDefinitionInformation](API_iotdeviceadvisor_SuiteDefinitionInformation.md) objects

## Errors
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_ListSuiteDefinitions_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/ListSuiteDefinitions) 

# ListSuiteRuns
<a name="API_iotdeviceadvisor_ListSuiteRuns"></a>

Lists runs of the specified Device Advisor test suite. You can list all runs of the test suite, or the runs of a specific version of the test suite.

Requires permission to access the [ListSuiteRuns](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_ListSuiteRuns_RequestSyntax"></a>

```
GET /suiteRuns?maxResults=maxResults&nextToken=nextToken&suiteDefinitionId=suiteDefinitionId&suiteDefinitionVersion=suiteDefinitionVersion HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_ListSuiteRuns_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_iotdeviceadvisor_ListSuiteRuns_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-request-uri-maxResults"></a>
The maximum number of results to return at once.  
Valid Range: Minimum value of 1. Maximum value of 50.

 ** [nextToken](#API_iotdeviceadvisor_ListSuiteRuns_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-request-uri-nextToken"></a>
A token to retrieve the next set of results.  
Length Constraints: Maximum length of 2000.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_ListSuiteRuns_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-request-uri-suiteDefinitionId"></a>
Lists the test suite runs of the specified test suite based on suite definition ID.  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_ListSuiteRuns_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-request-uri-suiteDefinitionVersion"></a>
Must be passed along with `suiteDefinitionId`. Lists the test suite runs of the specified test suite based on suite definition version.  
Length Constraints: Minimum length of 2. Maximum length of 255.

## Request Body
<a name="API_iotdeviceadvisor_ListSuiteRuns_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_ListSuiteRuns_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "suiteRunsList": [ 
      { 
         "createdAt": number,
         "endAt": number,
         "failed": number,
         "passed": number,
         "startedAt": number,
         "status": "string",
         "suiteDefinitionId": "string",
         "suiteDefinitionName": "string",
         "suiteDefinitionVersion": "string",
         "suiteRunId": "string"
      }
   ]
}
```

## Response Elements
<a name="API_iotdeviceadvisor_ListSuiteRuns_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_iotdeviceadvisor_ListSuiteRuns_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-response-nextToken"></a>
A token to retrieve the next set of results.  
Type: String  
Length Constraints: Maximum length of 2000.

 ** [suiteRunsList](#API_iotdeviceadvisor_ListSuiteRuns_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_ListSuiteRuns-response-suiteRunsList"></a>
An array of objects that provide summaries of information about the suite runs in the list.  
Type: Array of [SuiteRunInformation](API_iotdeviceadvisor_SuiteRunInformation.md) objects

## Errors
<a name="API_iotdeviceadvisor_ListSuiteRuns_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_ListSuiteRuns_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/ListSuiteRuns) 

# ListTagsForResource
<a name="API_iotdeviceadvisor_ListTagsForResource"></a>

Lists the tags attached to an IoT Device Advisor resource.

Requires permission to access the [ListTagsForResource](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_ListTagsForResource_RequestSyntax"></a>

```
GET /tags/resourceArn HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_ListTagsForResource_RequestParameters"></a>

The request uses the following URI parameters.

 ** [resourceArn](#API_iotdeviceadvisor_ListTagsForResource_RequestSyntax) **   <a name="iot-iotdeviceadvisor_ListTagsForResource-request-uri-resourceArn"></a>
The resource ARN of the IoT Device Advisor resource. This can be SuiteDefinition ARN or SuiteRun ARN.  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_ListTagsForResource_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_ListTagsForResource_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_iotdeviceadvisor_ListTagsForResource_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [tags](#API_iotdeviceadvisor_ListTagsForResource_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_ListTagsForResource-response-tags"></a>
The tags attached to the IoT Device Advisor resource.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.

## Errors
<a name="API_iotdeviceadvisor_ListTagsForResource_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_ListTagsForResource_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/ListTagsForResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/ListTagsForResource) 

# StartSuiteRun
<a name="API_iotdeviceadvisor_StartSuiteRun"></a>

Starts a Device Advisor test suite run.

Requires permission to access the [StartSuiteRun](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_StartSuiteRun_RequestSyntax"></a>

```
POST /suiteDefinitions/suiteDefinitionId/suiteRuns HTTP/1.1
Content-type: application/json

{
   "suiteDefinitionVersion": "string",
   "suiteRunConfiguration": { 
      "parallelRun": boolean,
      "primaryDevice": { 
         "certificateArn": "string",
         "deviceRoleArn": "string",
         "thingArn": "string"
      },
      "selectedTestList": [ "string" ]
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_StartSuiteRun_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_StartSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_StartSuiteRun_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_StartSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-request-suiteDefinitionVersion"></a>
Suite definition version of the test suite.  
Type: String  
Length Constraints: Minimum length of 2. Maximum length of 255.  
Required: No

 ** [suiteRunConfiguration](#API_iotdeviceadvisor_StartSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-request-suiteRunConfiguration"></a>
Suite run configuration.  
Type: [SuiteRunConfiguration](API_iotdeviceadvisor_SuiteRunConfiguration.md) object  
Required: Yes

 ** [tags](#API_iotdeviceadvisor_StartSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-request-tags"></a>
The tags to be attached to the suite run.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: No

## Response Syntax
<a name="API_iotdeviceadvisor_StartSuiteRun_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "createdAt": number,
   "endpoint": "string",
   "suiteRunArn": "string",
   "suiteRunId": "string"
}
```

## Response Elements
<a name="API_iotdeviceadvisor_StartSuiteRun_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [createdAt](#API_iotdeviceadvisor_StartSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-response-createdAt"></a>
Starts a Device Advisor test suite run based on suite create time.  
Type: Timestamp

 ** [endpoint](#API_iotdeviceadvisor_StartSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-response-endpoint"></a>
The response of an Device Advisor test endpoint.  
Type: String  
Length Constraints: Minimum length of 45. Maximum length of 75.

 ** [suiteRunArn](#API_iotdeviceadvisor_StartSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-response-suiteRunArn"></a>
Amazon Resource Name (ARN) of the started suite run.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [suiteRunId](#API_iotdeviceadvisor_StartSuiteRun_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_StartSuiteRun-response-suiteRunId"></a>
Suite Run ID of the started suite run.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

## Errors
<a name="API_iotdeviceadvisor_StartSuiteRun_Errors"></a>

 ** ConflictException **   
Sends a Conflict Exception.    
 ** message **   
Sends a Conflict Exception message.
HTTP Status Code: 400

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_StartSuiteRun_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/StartSuiteRun) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/StartSuiteRun) 

# StopSuiteRun
<a name="API_iotdeviceadvisor_StopSuiteRun"></a>

Stops a Device Advisor test suite run that is currently running.

Requires permission to access the [StopSuiteRun](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_StopSuiteRun_RequestSyntax"></a>

```
POST /suiteDefinitions/suiteDefinitionId/suiteRuns/suiteRunId/stop HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_StopSuiteRun_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_StopSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StopSuiteRun-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite run to be stopped.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

 ** [suiteRunId](#API_iotdeviceadvisor_StopSuiteRun_RequestSyntax) **   <a name="iot-iotdeviceadvisor_StopSuiteRun-request-uri-suiteRunId"></a>
Suite run ID of the test suite run to be stopped.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_StopSuiteRun_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_StopSuiteRun_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_iotdeviceadvisor_StopSuiteRun_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_iotdeviceadvisor_StopSuiteRun_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_StopSuiteRun_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/StopSuiteRun) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/StopSuiteRun) 

# TagResource
<a name="API_iotdeviceadvisor_TagResource"></a>

Adds to and modifies existing tags of an IoT Device Advisor resource.

Requires permission to access the [TagResource](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_TagResource_RequestSyntax"></a>

```
POST /tags/resourceArn HTTP/1.1
Content-type: application/json

{
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_TagResource_RequestParameters"></a>

The request uses the following URI parameters.

 ** [resourceArn](#API_iotdeviceadvisor_TagResource_RequestSyntax) **   <a name="iot-iotdeviceadvisor_TagResource-request-uri-resourceArn"></a>
The resource ARN of an IoT Device Advisor resource. This can be SuiteDefinition ARN or SuiteRun ARN.  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_TagResource_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [tags](#API_iotdeviceadvisor_TagResource_RequestSyntax) **   <a name="iot-iotdeviceadvisor_TagResource-request-tags"></a>
The tags to be attached to the IoT Device Advisor resource.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: Yes

## Response Syntax
<a name="API_iotdeviceadvisor_TagResource_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_iotdeviceadvisor_TagResource_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_iotdeviceadvisor_TagResource_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_TagResource_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/TagResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/TagResource) 

# UntagResource
<a name="API_iotdeviceadvisor_UntagResource"></a>

Removes tags from an IoT Device Advisor resource.

Requires permission to access the [UntagResource](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_UntagResource_RequestSyntax"></a>

```
DELETE /tags/resourceArn?tagKeys=tagKeys HTTP/1.1
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_UntagResource_RequestParameters"></a>

The request uses the following URI parameters.

 ** [resourceArn](#API_iotdeviceadvisor_UntagResource_RequestSyntax) **   <a name="iot-iotdeviceadvisor_UntagResource-request-uri-resourceArn"></a>
The resource ARN of an IoT Device Advisor resource. This can be SuiteDefinition ARN or SuiteRun ARN.  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Required: Yes

 ** [tagKeys](#API_iotdeviceadvisor_UntagResource_RequestSyntax) **   <a name="iot-iotdeviceadvisor_UntagResource-request-uri-tagKeys"></a>
List of tag keys to remove from the IoT Device Advisor resource.  
Array Members: Minimum number of 0 items. Maximum number of 50 items.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_UntagResource_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_iotdeviceadvisor_UntagResource_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_iotdeviceadvisor_UntagResource_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_iotdeviceadvisor_UntagResource_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
Sends a Resource Not Found exception.    
 ** message **   
Sends a Resource Not Found Exception message.
HTTP Status Code: 404

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_UntagResource_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/UntagResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/UntagResource) 

# UpdateSuiteDefinition
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition"></a>

Updates a Device Advisor test suite.

Requires permission to access the [UpdateSuiteDefinition](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_RequestSyntax"></a>

```
PATCH /suiteDefinitions/suiteDefinitionId HTTP/1.1
Content-type: application/json

{
   "suiteDefinitionConfiguration": { 
      "devicePermissionRoleArn": "string",
      "devices": [ 
         { 
            "certificateArn": "string",
            "deviceRoleArn": "string",
            "thingArn": "string"
         }
      ],
      "intendedForQualification": boolean,
      "isLongDurationTest": boolean,
      "protocol": "string",
      "rootGroup": "string",
      "suiteDefinitionName": "string"
   }
}
```

## URI Request Parameters
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_RequestParameters"></a>

The request uses the following URI parameters.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_UpdateSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-request-uri-suiteDefinitionId"></a>
Suite definition ID of the test suite to be updated.  
Length Constraints: Minimum length of 12. Maximum length of 36.  
Required: Yes

## Request Body
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [suiteDefinitionConfiguration](#API_iotdeviceadvisor_UpdateSuiteDefinition_RequestSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-request-suiteDefinitionConfiguration"></a>
Updates a Device Advisor test suite with suite definition configuration.  
Type: [SuiteDefinitionConfiguration](API_iotdeviceadvisor_SuiteDefinitionConfiguration.md) object  
Required: Yes

## Response Syntax
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "createdAt": number,
   "lastUpdatedAt": number,
   "suiteDefinitionArn": "string",
   "suiteDefinitionId": "string",
   "suiteDefinitionName": "string",
   "suiteDefinitionVersion": "string"
}
```

## Response Elements
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [createdAt](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-createdAt"></a>
Timestamp of when the test suite was created.  
Type: Timestamp

 ** [lastUpdatedAt](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-lastUpdatedAt"></a>
Timestamp of when the test suite was updated.  
Type: Timestamp

 ** [suiteDefinitionArn](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-suiteDefinitionArn"></a>
Amazon Resource Name (ARN) of the updated test suite.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.

 ** [suiteDefinitionId](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-suiteDefinitionId"></a>
Suite definition ID of the updated test suite.  
Type: String  
Length Constraints: Minimum length of 12. Maximum length of 36.

 ** [suiteDefinitionName](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-suiteDefinitionName"></a>
Updates the suite definition name. This is a required parameter.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.

 ** [suiteDefinitionVersion](#API_iotdeviceadvisor_UpdateSuiteDefinition_ResponseSyntax) **   <a name="iot-iotdeviceadvisor_UpdateSuiteDefinition-response-suiteDefinitionVersion"></a>
Suite definition version of the updated test suite.  
Type: String  
Length Constraints: Minimum length of 2. Maximum length of 255.

## Errors
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_Errors"></a>

 ** InternalServerException **   
Sends an Internal Failure exception.    
 ** message **   
Sends an Internal Failure Exception message.
HTTP Status Code: 500

 ** ValidationException **   
Sends a validation exception.    
 ** message **   
Sends a Validation Exception message.
HTTP Status Code: 400

## See Also
<a name="API_iotdeviceadvisor_UpdateSuiteDefinition_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotdeviceadvisor-2020-09-18/UpdateSuiteDefinition) 